/*
 *  Copyright 2002-2005, Mersad Team, Allameh Helli High School (NODET).
 *
 *  This program is free software, you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 *  GNU Library General Public License for more details.
 *
 *  This file is created by: Meisam Vosoughpour
 *
 *  Released on Monday 1 August 2005, 10 Mordad 1384 by Mersad RoboCup Team.
 *  For more information please read README file.
*/

#ifndef __DEFENSE_H
#define __DEFENSE_H

#include <Positioning.h>
#include <AdvancedAction.h>

class Defense: public AdvancedAction
{
protected:
	Point defensePoint;
	Command *defenseCommand;
	
	bool isPlayOn;
	
	int checkMarkPlayer(Point &homePoint, float senseX, float senseY);
	void checkGoalDist(Point &homePoint);
	void gotoTir(Point tirPoint, float currentAngle);
	void checkForGoal(Point &homePint, const Library &library);
	Point makeMarkPoint(Point playerPoint);

public:
	Defense(const WorldModel *worldModel);

	virtual void execute(Form &form, const Library &library);
	virtual float getValue(const Library &library);
	Point getHomePoint(int playerUniNum);
};

#endif // __DEFENSE_H
