/*
 *  Copyright 2002-2005, Mersad Team, Allameh Helli High School (NODET).
 *
 *  This program is free software, you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 *  GNU Library General Public License for more details.
 *
 *  This file is created by: Mohammad Salehe
 *
 *  Released on Monday 1 August 2005, 10 Mordad 1384 by Mersad RoboCup Team.
 *  For more information please read README file.
*/

#ifndef __NONPLAYON_H
#define __NONPLAYON_H

#include <AdvancedAction.h>

class NonPlayOnBackBall: public AdvancedAction
{
protected:
	int status;
public:
	NonPlayOnBackBall(const WorldModel *worldModel);

	virtual void execute(Form &form, const Library &library);
	virtual float getValue(const Library &library);
	int getStatus();
};

class NonPlayOnGotoKick: public AdvancedAction
{
protected:
	int status;
public:
	NonPlayOnGotoKick(const WorldModel *worldModel);

	virtual void execute(Form &form, const Library &library);
	virtual float getValue(const Library &library);
	int getStatus();
};

class NonPlayOnBeforeKickOff: public AdvancedAction
{
protected:
	int status;
	bool kickerFlag;
public:
	NonPlayOnBeforeKickOff(const WorldModel *worldModel);

	virtual void execute(Form &form, const Library &library);
	virtual float getValue(const Library &library);
	Point getMovePoint(unsigned uniNum);
	Point getMovePoint();
	void setIsKicker(bool kickerFlagArg);
};

class GoalieCatchOffense: public AdvancedAction
{
protected:
	int status;
public:
	GoalieCatchOffense(const WorldModel *worldModel);

	virtual void execute(Form &form, const Library &library);
	virtual float getValue(const Library &library);
	Point getHomePoint(unsigned uniNum);
	Point getHomePoint();
	int getStatus();
};

class HoldBall: public AdvancedAction
{
protected:
public:
	HoldBall(const WorldModel *worldModel);

	virtual void execute(Form &form, const Library &library);
	virtual float getValue(const Library &library);
};

#endif // __NONPLAYON_H
