/*
 *  Copyright 2002-2005, Mersad Team, Allameh Helli High School (NODET).
 *
 *  This program is free software, you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 *  GNU Library General Public License for more details.
 *
 *  This file is created by: Mostafa Rokooey
 *
 *  Released on Monday 1 August 2005, 10 Mordad 1384 by Mersad RoboCup Team.
 *  For more information please read README file.
*/

#ifndef __SHOOT_H
#define __SHOOT_H

#include <InterceptCalculate.h>
#include <AdvancedAction.h>

//  Maximum Value for NUMBEOBROFSHOOTPOINTS is 60
#define NUMBEROFSHOOTPOINTS 20
#define SHOOTPOINTSX 52.5

class Shoot: public AdvancedAction
{

public:
	Shoot(const WorldModel *worldModel);
	virtual ~Shoot();

	virtual void execute(Form &form, const Library &library);
	virtual float getValue(const Library &library);

    InterceptCalculate shootIntercept;

	int shootLogLevel;

    Point shootPoints[60];
    float shootWeights[60];
	Command *shootCommands[60];
	Command *shootCommand;
	
    float catchRate;
    float noiseRate;
    float goaliePosDeviationRate;
    float farToGoalieRate;
    float goalSeenRate;
	float goalieMistakeRate;
	float ballFastMovingRate;

    float getCatchWeight(int shootNum);
    float getNoiseWeight(int shootNum);
    float getGoaliePosDeviationWeight(void);
    float getFarToGoalieWeight(int shootNum);
    float getGoalSeenWeight(int shootNum);
	float getGoalieMistakeWeight(void);
	float getBallFastMovingWeight(const Library &library);
	
    void setShootRates(void);
	bool getFastest(int shootNum);
    bool kickMaxPower(int shootNum);
};

#endif // __SHOOT_H
