/*
 *  Copyright 2002-2005, Mersad Team, Allameh Helli High School (NODET).
 *
 *  This program is free software, you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 *  GNU Library General Public License for more details.
 *
 *  This file is created by: Ahmad Boorghany
 *
 *  Released on Monday 1 August 2005, 10 Mordad 1384 by Mersad RoboCup Team.
 *  For more information please read README file.
*/

#ifndef __VIRTUAL_PASS_H
#define __VIRTUAL_PASS_H


#include <Pass.h>
#include <KickCalculate.h>


#define VIRTUAL_KICK_DIR_STEP 7.50
#define VIRTUAL_KICK_DIR_NUM (unsigned)(360 / VIRTUAL_KICK_DIR_STEP)
#define VIRTUAL_KICK_VEL_NUM 4
#define VIRTUAL_KICK_CALCULATES_NUM (unsigned) \
		(VIRTUAL_KICK_DIR_NUM * VIRTUAL_KICK_VEL_NUM)


class WorldModel;

class VirtualKickInterceptCalculate: public KickInterceptCalculate
{
public:
	virtual ~VirtualKickInterceptCalculate();

	void init(const WorldModel *worldModel,
		const Ball &nextBall, const Vector &ballVel,
		InterceptCalculate &interCalc);
};

class VirtualKickCalculate: public KickCalculate
{
public:
	virtual ~VirtualKickCalculate();

	void init();
	void update(const WorldModel *worldModel, const Player &kickPlayer);

};

class VirtualCrossCalculate: public CrossCalculate
{
public:
	virtual ~VirtualCrossCalculate();

	void init();
	void update(const WorldModel *worldModel, const Player &kickPlayer);
};

class VirtualPass: public Pass
{
protected:
	VirtualKickCalculate virtualKickCalc;

	unsigned lastUpdate;

public:
	VirtualPass(const WorldModel *worldModel);

	float getValue(const Player &kickPlayer);
	void manager(Form &form, const Library &library);
};


#endif // __VIRTUAL_PASS_H

