/*
 *  Copyright 2002-2005, Mersad Team, Allameh Helli High School (NODET).
 *
 *  This program is free software, you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 *  GNU Library General Public License for more details.
 *
 *  This file is created by: Mohammad Salehe
 *
 *  Released on Monday 1 August 2005, 10 Mordad 1384 by Mersad RoboCup Team.
 *  For more information please read README file.
*/

#ifndef __PENALTY_DECISION_H
#define __PENALTY_DECISION_H


#include <Defines.h>
#include <BodyDecision.h>
#include <WithoutBallPlayOnDecision.h>


class PenaltyDecision: public BodyDecision
{
protected:
	WithoutBallPlayOnDecision withoutBallPlayOnDecision;

	// Return Values: 1=not kicker , 2=kicker
	int selectBallKicker();
	bool doneFlag;

public:
	PenaltyDecision(const WorldModel *worldModel);
	virtual ~PenaltyDecision();
	// Return Values : 0:nothing , 1:Rotate Field
//	int checkPlayMode(); OOOOOOOOOOH
	
	virtual void decide(int quickLevel,
			Form &form, const Library &library);
};


#endif // __PENALTY_DECISION_H

