/*
 *  Copyright 2002-2005, Mersad Team, Allameh Helli High School (NODET).
 *
 *  This program is free software, you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 *  GNU Library General Public License for more details.
 *
 *  This file is created by: Ahmad Boorghany
 *
 *  Released on Monday 1 August 2005, 10 Mordad 1384 by Mersad RoboCup Team.
 *  For more information please read README file.
*/

#ifndef __WITH_BALL_PLAY_ON_DECISION_H
#define __WITH_BALL_PLAY_ON_DECISION_H


#include <BodyDecision.h>


class WithBallPlayOnDecision: public BodyDecision
{
protected:
	ActionType lastWithBallDecide;

	void initWeights();
	void loadWeights(int quickLevel);

public:
	WithBallPlayOnDecision(const WorldModel *worldModel);
	virtual ~WithBallPlayOnDecision();

	virtual void decide(int quickLevel, Form &form, const Library &library);

	ActionType getLastWithBallDecide() const;
};


#endif // __WITH_BALL_PLAY_ON_DECISION_H

