/*
 *  Copyright 2002-2005, Mersad Team, Allameh Helli High School (NODET).
 *
 *  This program is free software, you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 *  GNU Library General Public License for more details.
 *
 *  This file is created by: Sassan Haradji
 *
 *  Released on Monday 1 August 2005, 10 Mordad 1384 by Mersad RoboCup Team.
 *  For more information please read README file.
*/

#include <BasicDash.h>
#include <AdvancedAgent.h>
#include <BackToForwardPlan.h>
#include <BackPlan.h>
#include <MiddlePlan.h>
#include <ForwardPlan.h>
#include <Logger.h>
#include <Basics.h>
#include <cassert>

using namespace std;
using namespace Basics;

BackToForwardPlan::BackToForwardPlan(const WorldModel *wm, Form &form,
		const Library &library):Plan("BackToForward", wm, form, library)
{
}

BackToForwardPlan::~BackToForwardPlan()
{
}

void BackToForwardPlan::decide()
{
	LOG << "BackToForwardPlan::decide" << endl;

	Plan::decide();

	startPlan(new BackPlan(wm, form, library));
	startPlan(new MiddlePlan(wm, form, library));
	startPlan(new ForwardPlan(wm, form, library));
	
	LOG << "BackToForwardPlan Now Kill Program" << endl;
	assert(0);
}

double BackToForwardPlan::successRate()
{
	return 1.0;
}

bool BackToForwardPlan::isFinished()
{	
	if (wm->getBody().getPos().getX() <
			config["Agent"]["PlanningSystem"]["GoalPlanX"].asFloat() - 2)
		return false;
	return true;
}
