/*
 *  Copyright 2002-2005, Mersad Team, Allameh Helli High School (NODET).
 *
 *  This program is free software, you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 *  GNU Library General Public License for more details.
 *
 *  This file is created by: Ahmad Boorghany
 *
 *  Released on Monday 1 August 2005, 10 Mordad 1384 by Mersad RoboCup Team.
 *  For more information please read README file.
*/


#ifndef __CROSS_PLAN_H_
#define __CROSS_PLAN_H_

#include <Plan.h>

class CrossPlan: public Plan
{
public:
	CrossPlan(const WorldModel *wm, Form &form, const Library &library);
	~CrossPlan();

	virtual void decide();

	virtual double successRate();
	virtual bool isFinished();

	void resetAfterCopy();
        
protected:
	bool fabric;
	bool coorse;
	bool intercepting;

	Plan *srpPlan;
	Plan *passPlan;
	Plan *shootPlan;
	Plan *dribblePlan;
	Plan *selectedPlan;

	unsigned lastTurnTime;

	void GlobalPositioning();
};

#endif // __CROSS_PLAN_H_

