/*
 *  Copyright 2002-2005, Mersad Team, Allameh Helli High School (NODET).
 *
 *  This program is free software, you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 *  GNU Library General Public License for more details.
 *
 *  This file is created by: Darioush Jalali, Sassan Haradji
 *
 *  Released on Monday 1 August 2005, 10 Mordad 1384 by Mersad RoboCup Team.
 *  For more information please read README file.
*/


#ifndef __CROSS_POS_PLAN_H_
#define __CROSS_POS_PLAN_H_

#include <Plan.h>
#include <Types.h>

class CrossPosPlan : public Plan
{
protected:
	Side side;

	std::map <RoleType, const Player*> roles;
	void updateRoles();
	const Vector preserveShapeUpdate(RoleType role);
	RoleType myRole;

	unsigned updatedRoles;
public:
	CrossPosPlan(const WorldModel *wm, Form &form, const Library &library, Side side);
	~CrossPosPlan();

	virtual void decide();

	virtual double successRate();
	virtual bool isFinished();
};

#endif // __CROSS_POS_PLAN_H_
