/*
 *  Copyright 2002-2005, Mersad Team, Allameh Helli High School (NODET).
 *
 *  This program is free software, you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 *  GNU Library General Public License for more details.
 *
 *  This file is created by: Ahmad Boorghany
 *
 *  Released on Monday 1 August 2005, 10 Mordad 1384 by Mersad RoboCup Team.
 *  For more information please read README file.
*/

#include <cmath>
#include <BasicDash.h>
#include <AdvancedAgent.h>
#include <OffensePosPlan.h>
#include <Logger.h>
#include <Basics.h>
#include <Degree.h>
#include <SayEncoding.h>
#include <cassert>

using namespace std;
using namespace Basics;
using namespace Degree;

OffensePosPlan::OffensePosPlan(const WorldModel *wm, Form &form,
		const Library &library): Plan("OffensePos", wm, form, library),
		virtualPass(wm)
{
}

OffensePosPlan::~OffensePosPlan()
{
}

void OffensePosPlan::decide()
{
	LOG << "OffensePosPlan::decide" << endl;

	Point offensePoint =
			library.positioning.getHomePoint(wm->getBody().getUniNum());

	Command *command = library.positioning.getPositioningCommand(offensePoint);
	command->setCreator(AT_OFFENSE);

	throw command;

	LOG << "OffencePosPlan Now Kill Program" << endl;
	assert(0);
}

double OffensePosPlan::successRate()
{
	return 1.0;
}

bool OffensePosPlan::isFinished()
{
	if(!wm->isBallKickable() &&	library.gwSelection == WOBS_OFFENSE)
		return false;
	return true;
}

