/*
 *  Copyright 2002-2005, Mersad Team, Allameh Helli High School (NODET).
 *
 *  This program is free software, you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 *  GNU Library General Public License for more details.
 *
 *  This file is created by: Sassan Haradji
 *
 *  Released on Monday 1 August 2005, 10 Mordad 1384 by Mersad RoboCup Team.
 *  For more information please read README file.
*/

#include <DribblePlan.h>
#include <Logger.h>

using namespace std;

DribblePlan::DribblePlan(const WorldModel *wm, Form &form,
			const Library &library) : Plan("Dribble", wm, form, library),
			basicDribble(new Dribble(wm)), finished(false), getVal(false)
{
}

DribblePlan::~DribblePlan()
{
	delete basicDribble;
}

void DribblePlan::decide()
{
	LOG << "DribblePlan::decide" << endl;
	if (!getVal || valSetCycle != wm->getCurCycle())
		value = basicDribble->getValue(library) - 20;
	valSetCycle = wm->getCurCycle();
	getVal = true;
	basicDribble->execute(form, library);
	finished = true;
	throw basicDribble->getCommand();
}

double DribblePlan::successRate()
{
	if (!getVal || valSetCycle != wm->getCurCycle())
		value = basicDribble->getValue(library) - 20;
	valSetCycle = wm->getCurCycle();
	getVal = true;
	if (value < -200) return 0;
	return value / 1000 + .2;
}

bool DribblePlan::isFinished()
{
	if (wm->isBallKickable()) 
		return finished;
	return true;
}
