/*
 *  Copyright 2002-2005, Mersad Team, Allameh Helli High School (NODET).
 *
 *  This program is free software, you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 *  GNU Library General Public License for more details.
 *
 *  This file is created by: Sassan Haradji
 *
 *  Released on Monday 1 August 2005, 10 Mordad 1384 by Mersad RoboCup Team.
 *  For more information please read README file.
*/

#include <PassPlan.h>
#include <AdvancedAgent.h>
#include <Logger.h>
#include <string>

using namespace std;

PassPlan::PassPlan(const WorldModel *wm, Form &form, const Library &library,
		unsigned models, unsigned number, float passAngleFrom, float passAngleTo,
		float playerAngleFrom, float playerAngleTo):
		Plan("Pass", wm, form, library),
		exactPass(library.pass.getTheBestPass(models, number,
		passAngleFrom, passAngleTo, playerAngleFrom, playerAngleTo)),
		finished(false)
{
}

PassPlan::~PassPlan()
{
}

void PassPlan::decide()
{
	LOG << "PassPlan::decide" << endl;
	finished = true;
	throw library.pass.execute(exactPass, form, library);
}

double PassPlan::successRate()
{
	float value = exactPass.weight + 5;
	if (value < -200) return 0;
	if (exactPass.model == PAM_NONE) return 0;
	return value / 1000 + .2;
}

bool PassPlan::isFinished()
{
	if (wm->isBallKickable()) 
		return finished;
	return true;
}
