/*
 *  Copyright 2002-2005, Mersad Team, Allameh Helli High School (NODET).
 *
 *  This program is free software, you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 *  GNU Library General Public License for more details.
 *
 *  This file is created by: Darioush Jalali
 *
 *  Released on Monday 1 August 2005, 10 Mordad 1384 by Mersad RoboCup Team.
 *  For more information please read README file.
*/

#include "Scenario.h"
#include <iostream>
#include "Logger.h"
#include <cassert>

using namespace std;

Scenario::Scenario(const CoachWorldModel * worldModel, const CoachWorldModelHistory 
					* worldModelHistory, Connection* connection) :
					Trainer(worldModel, worldModelHistory, connection)
{
	isRunning = false;					
}


Scenario::~Scenario () { };

void Scenario::execute(bool isTrainer) {
	assert(isTrainer);
	if (isRunning) {
		LOG << "Scenario::execute ... isRunning = true" <<endl;
		monitor();
		if (endCondition()) {
			LOG <<	"Scenario::execute ... endCondition() reached" <<endl;
			isRunning = false;
			conclude();
			cleanUp();
		}
	} else {
		LOG << "Scenario::execute ... isRunning = false" <<endl;
		if (startCondition()) {
			LOG <<	"Scenario::execute ... startCondition() reached" <<endl;
			isRunning = true;
			setUp();
		}
	}
}

void Scenario::cleanUp() {
	RecoverCommand command(AT_ADVANCED_COACH);
	connection->send((Command *) (&command));
};
	


