/*
 *  Copyright 2002-2005, Mersad Team, Allameh Helli High School (NODET).
 *
 *  This program is free software, you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 *  GNU Library General Public License for more details.
 *
 *  This file is created by: Darioush Jalali
 *
 *  Released on Monday 1 August 2005, 10 Mordad 1384 by Mersad RoboCup Team.
 *  For more information please read README file.
*/

#ifndef __TRAINER_H_
#define __TRAINER_H_

#include "Connection.h"
#include "Command.h"
#include "Config.h"
#include "CoachWorldModel.h"

/*
	What is the trainer?
	The trainer is a TASK  like that sets up a scenario, and monitors the progress
	of it.
	Only one TRAINER instance exists, and is a member of advancedcoach
	The trainer has access to EVERYTHING.	
 */
#define OUR_TEAMNAME (config["Agent"]["Public"]["TeamName"].asString())

class Trainer {
 protected:
 	const CoachWorldModel * worldModel;
	const CoachWorldModelHistory * worldModelHistory;
 	Connection * connection;
 public:
	Trainer(const CoachWorldModel * worldModel, const CoachWorldModelHistory * worldModelHistory,
			Connection* connection);
	virtual ~Trainer();	
	/*
	 	This functions will be called every cycle by the AdvancedCoach
	 */
    virtual void execute(bool isTrainer = true) = 0;
	virtual void setWorldModel(CoachWorldModel * worldModel);
	virtual void setWorldModelHistory(CoachWorldModelHistory * worldModelHistory);
};

#endif
