/*
 *  Copyright 2002-2005, Mersad Team, Allameh Helli High School (NODET).
 *
 *  This program is free software, you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 *  GNU Library General Public License for more details.
 *
 *  This file is created by: Ahmad Boorghany
 *  and is modified by: Mohammad Salehe, Sassan Haradji
 *
 *  Released on Monday 1 August 2005, 10 Mordad 1384 by Mersad RoboCup Team.
 *  For more information please read README file.
*/

#ifndef __BASICS_H
#define __BASICS_H


#include <string>


enum ReRateMode {
    RRM_DIRECT,
    RRM_REVERSE
};

namespace Basics
{
	extern bool isInPlayers(const unsigned num, const char *str);
	extern unsigned charToUniNum(const char str);
	extern char uniNumToChar(const unsigned num);
	extern unsigned firstPlayerInList(const std::string list,
			const std::string blackList);
	extern float reRate(float value, float a, float b, float c, float d,
			ReRateMode mode = RRM_DIRECT);
	extern float sigmoid(float x);
	extern unsigned changeIntBase(int number, int base, std::string &str);
	extern unsigned baghimande(int number, unsigned base);
	extern int sign(float number);
}


#endif // __CONFIG_H

